﻿using System;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows.Media;
using System.Text;
using Styx;
using Styx.Common;
using Styx.WoWInternals.WoWObjects;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;

namespace Project_1
{
    public partial class Prg1Set : Form
    {
        public Prg1Set()
        {
            InitializeComponent();
            GUISaver.Instance.Load();
            checkBox1.Checked = GUISaver.Instance.Timer.ToBoolean();
            checkBox2.Checked = GUISaver.Instance.CSearch.ToBoolean();
            textBox2.Text = GUISaver.Instance.Itemnum.ToString();
            textBox2.Enabled = GUISaver.Instance.CSearch.ToBoolean();
            checkBox3.Checked = GUISaver.Instance.OnyxE.ToBoolean();
            checkBox4.Checked = GUISaver.Instance.DarkS.ToBoolean();
            checkBox6.Checked = GUISaver.Instance.NetherS.ToBoolean();


        }
        private void button1_Click(object sender, EventArgs e)
        {
            GUISaver.Instance.Save();
            Logging.Write(Colors.Aqua, "[Object Finder] --------------------------");
            Logging.Write(Colors.Red, "[Object Finder] Search settings:");
            Logging.Write(Colors.Green, "[Object Finder] Onyx Egg: {0}", GUISaver.Instance.OnyxE);
            Logging.Write(Colors.Green, "[Object Finder] Dark Soil: {0}", GUISaver.Instance.DarkS);
            Logging.Write(Colors.Green, "[Object Finder] Netherwing Egg: {0}", GUISaver.Instance.NetherS);
            Logging.Write(Colors.Green, "[Object Finder] Custom Search: {0}", GUISaver.Instance.CSearch);
            Logging.Write(Colors.Green, "[Object Finder] Item Number: {0}", GUISaver.Instance.Itemnum);
            Logging.Write(Colors.Red, "[Object Finder] Timer settings:");
            Logging.Write(Colors.Green, "[Object Finder] Timer: {0}", GUISaver.Instance.Timer);
            Logging.Write(Colors.Green, "[Object Finder] Settings Saved!");
            Logging.Write(Colors.Aqua, "[Object Finder] --------------------------");
            Close();
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=H8ZUDBCE8TMUN");
            linkLabel1.LinkVisited = true;
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            GUISaver.Instance.Itemnum = textBox2.Text;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            GUISaver.Instance.Timer = checkBox1.Checked.ToString();
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            GUISaver.Instance.CSearch = checkBox2.Checked.ToString();
            if (checkBox2.Checked == true)
            {
                // Enable Textbox
                textBox2.Enabled = true;
                // Check boxes Checked
                checkBox3.Checked = false;
                checkBox4.Checked = false;
                checkBox6.Checked = false;
                // Check boxes Enabled
                checkBox3.Enabled = false;
                checkBox4.Enabled = false;
                checkBox6.Enabled = false;
            }
            else
            {
                // Check boxes Enabled
                checkBox3.Enabled = true;
                checkBox4.Enabled = true;
                checkBox6.Enabled = true;
                // Disable Textbox
                textBox2.Enabled = false;
            }
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            GUISaver.Instance.OnyxE = checkBox3.Checked.ToString();
            if (checkBox3.Checked == true)
            {
                // Item Number box
                textBox2.Enabled = false;
                // Check boxes checked
                checkBox2.Checked = false;
                checkBox4.Checked = false;
                checkBox6.Checked = false;
                // Check boxes Enabled
                checkBox2.Enabled = false;
                checkBox4.Enabled = false;
                checkBox6.Enabled = false;
            }
            else
            {
                // Check boxes Enabled
                checkBox2.Enabled = true;
                checkBox4.Enabled = true;
                checkBox6.Enabled = true;
            }
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            GUISaver.Instance.DarkS = checkBox4.Checked.ToString();
            if (checkBox4.Checked == true)
            {
                // Item Number box
                textBox2.Enabled = false;
                // Check boxes Checked
                checkBox2.Checked = false;
                checkBox3.Checked = false;
                checkBox6.Checked = false;
                // Check Boxes Enabled
                checkBox2.Enabled = false;
                checkBox3.Enabled = false;
                checkBox6.Enabled = false;
            }
            else
            {
                // Check Boxes Enabled
                checkBox2.Enabled = true;
                checkBox3.Enabled = true;
                checkBox6.Enabled = true;
            }
        }

        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            GUISaver.Instance.NetherS = checkBox6.Checked.ToString();
            if (checkBox6.Checked == true)
            {
                // Item Number box
                textBox2.Enabled = false;
                // Check boxes Checked
                checkBox2.Checked = false;
                checkBox3.Checked = false;
                checkBox4.Checked = false;
                // Check Boxes Enabled
                checkBox2.Enabled = false;
                checkBox3.Enabled = false;
                checkBox4.Enabled = false;
            }
            else
            {
                // Check Boxes Enabled
                checkBox2.Enabled = true;
                checkBox3.Enabled = true;
                checkBox4.Enabled = true;
            }
        }
    }
}
