﻿#region Honorbuddy Cores
// HB Cores
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.POI;
using Styx.Common.Helpers;
using Styx.CommonBot.Frames;
using Styx.CommonBot.Profiles;
using Styx.Pathing;
using Styx.Helpers;
using Buddy.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;
#endregion

#region System Cores
// System Cores
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Threading;
using System.Windows.Media;
using System.Windows.Forms;
using System.Text;
#endregion

/*
 * TODO:
 *      1. Rebuild Timer so it uses less then 5 seconds. 
 *      2. Added a section to GUI for the timer so it can either be enabled / disabled. - DONE 
 *      3. Insert enable / disable function into Plugin. - DONE
 *      4. Make plugin work with profiles. (Currently works with GB2 but very buggy!) - BETA
 */

//              VERSION 0.3
//                  By Tricen
//         [Object Finder] Locating Objects near you since... well.... unknown.
//                      Donate by clicking the donation link in the settings menu or on the forums!
//                      Help keep this project going!

namespace Project_1
{
    public class PRJ1 : HBPlugin
    {
        #region Plugin Information
        // Plugin Information
        public override string Name { get { return "Object Finder";  } }
        public override string Author { get { return "Tricen"; } }
        public override Version Version { get { return new Version(0, 4); } }
        public override bool WantButton { get { return true; } }
        public override string ButtonText { get { return "Settings";  } }
        public override void OnButtonPress() { var GUI = new Prg1Set(); GUI.ShowDialog(); }
        #endregion

        #region Basics (Me / WoWGameObject / Timers)
        // Basics
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private WoWGameObject objectfind = null;
        private static WaitTimer GetDelay = WaitTimer.FiveSeconds;
        #endregion 

        #region Anti-Spam
        // Prevents Spamming in LOG
        private int antispam = 0;
        private int antispam1 = 0;
        #endregion

        #region Enable / Disable
        public override void OnEnable()
        {
            Logging.Write(Colors.CornflowerBlue, "[Object Finder] Enabled");

        }

        public override void OnDisable()
        {
            Logging.Write(Colors.CornflowerBlue, "[Object Finder] Disabled");
        }
        #endregion

        #region Pulse functions
        public override void Pulse()
        {
            bool TimeSET = GUISaver.Instance.Timer.ToBoolean();
            if ((Me.IsBeingAttacked && !Me.Mounted) || (Me.IsActuallyInCombat && !Me.Mounted)
                         || !Me.IsAlive || Me.OnTaxi) 
            {
                return;
            }
            if (TimeSET == true)
            {
                if ((!GetDelay.IsFinished))
                {
                    return;
                }
            }

            WoWGameObject objectfind = RunScanner();

            if (objectfind == null)
            {
                if (antispam == 0)
                {
                    if (Me.Mounted)
                    {
                        Styx.Helpers.KeyboardManager.KeyUpDown((Char)Keys.Space);
                    }
                    Logging.Write(Colors.DarkRed, "[Object Finder] None Found");
                    antispam = 1;
                }
            }
            else if (objectfind.Distance > objectfind.InteractRange)
            {
                antispam = 0;
                if (antispam1 == 0)
                {
                    antispam1 = 1;
                    WoWMovement.MoveStop();
                    Logging.Write(Colors.DarkGreen, "[Object Finder] Moving to {0}", objectfind.Location); 
                }
                if (Me.IsFlying)
                {
                    Flightor.MoveTo(objectfind.Location);
                }
                else
                {
                    Navigator.MoveTo(objectfind.Location);
                }
            }
            else if (Me.IsMoving)
            {
                //Navigator.PlayerMover.MoveStop();
                //WoWMovement.MoveStop();
                Flightor.MountHelper.Dismount();
            }
            else
            {
                antispam1 = 0;
                Gatherit(objectfind);
            }
        }
        #endregion

        #region RunScanner Function
        public WoWGameObject RunScanner()
        {
            uint GetNUM = GUISaver.Instance.Itemnum.ToUInt32();
            bool GetONYX = GUISaver.Instance.OnyxE.ToBoolean();
            bool GetCS = GUISaver.Instance.CSearch.ToBoolean();
            bool GetDark = GUISaver.Instance.DarkS.ToBoolean();
            bool GetNETH = GUISaver.Instance.NetherS.ToBoolean();

            // Update Objects
            ObjectManager.Update();

            if (GetCS == true)
            {
                #region Custom Searching
                // Searching for ObjectID input by settings.
                var Dark_List = ObjectManager.GetObjectsOfTypeFast<WoWGameObject>().
                    Where(o =>
                        (o.Entry == GetNUM) && Navigator.CanNavigateFully(Me.Location, o.Location)
                        ).OrderBy(o => o.Distance).ToList();

                return Dark_List.FirstOrDefault();
                #endregion
            }
            else if (GetONYX == true)
            {
                #region Onyx Egg
                var Onyx_Egg = ObjectManager.GetObjectsOfTypeFast<WoWGameObject>().
                 Where(o =>
                      (o.Entry == 214945)  && Navigator.CanNavigateFully(Me.Location, o.Location)      
                      ).OrderBy(o => o.Distance).ToList();

                return Onyx_Egg.FirstOrDefault();
                #endregion
            }
            else if (GetNETH== true)
            {
                #region Netherwing Egg
                var Nether_Egg = ObjectManager.GetObjectsOfTypeFast<WoWGameObject>().
                 Where(o =>
                      (o.Entry == 185915) && Navigator.CanNavigateFully(Me.Location, o.Location)      
                      ).OrderBy(o => o.Distance).ToList();

                return Nether_Egg.FirstOrDefault();
                #endregion
            }
            else if (GetDark == true)
            {
                #region Dark Soil
                var Tree_List = ObjectManager.GetObjectsOfTypeFast<WoWGameObject>().
                 Where(o =>
                      (o.Entry == 210565) 
                 && Navigator.CanNavigateFully(Me.Location, o.Location)          // get rid of unreachable trees  
                 ).OrderBy(o => o.Distance).ToList();
                return Tree_List.FirstOrDefault();
                #endregion
            }
            else
            {
                Logging.Write("[Object Finder] - Internal Error - Object Scanner NULLED");
                return null;
            }
        }
        #endregion

        #region Gathering Portion
        public void Gatherit(WoWGameObject objectfinder)
        {
            GetDelay.Reset();
            objectfinder.Interact();
        }
        #endregion
    }
}