﻿using System;
using System.IO;
using Styx;
using Styx.Common;
using Styx.Helpers;

namespace Project_1
{
    public class GUISaver : Settings
    {
        public static readonly GUISaver Instance = new GUISaver();
        public GUISaver() : base (Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"Settings/ObjectFinder-Settings.xml"))
        {

        }

        // Custom Item Number (Default Dark Soil)
        [Setting, DefaultValue("210565")]
        public string Itemnum { get; set; }

        //Timer Setting (5 seconds)
        [Setting, DefaultValue("true")]
        public string Timer { get; set; }

        // Custom Search Enabled
        [Setting, DefaultValue("true")]
        public string CSearch { get; set; }

        [Setting, DefaultValue("false")]
        public string OnyxE { get; set; }
        
        [Setting, DefaultValue("false")]
        public string DarkS { get; set; }

        [Setting, DefaultValue("false")]
        public string NetherS { get; set; }

    }
}
